//audio
datablock AudioProfile(TF2BigRevolverShotSound)
{
   filename    = "./AmbassadorFire.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("TF2BigRevolver",   '<bitmap:add-ons/Weapon_TF2Ambassador/CI_revolver> %1',    '%2 <bitmap:add-ons/Weapon_TF2Ambassador/CI_revolver> %1',0.75,1);
AddDamageType("RevolverHeadshot",   '<bitmap:add-ons/Weapon_TF2Ambassador/CI_revolvershot> %1',    '%2 <bitmap:add-ons/Weapon_TF2Ambassador/CI_revolvershot> %1',0.75,1);

//Trail
datablock ParticleData(TF2BigRevolverTrailParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 1;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/thinring";
   spinSpeed		   = 0.0;
   spinRandomMin		= 0.0;
   spinRandomMax		= 0.0;
   colors[0]     = "1 1 0.2 0.9";
   colors[1]     = "1 1 0.1 0.5";
   colors[2]     = "1 1 0 0";

   sizes[0]      = 0.6;
   sizes[1]      = 0.6;
   sizes[2]      = 0.6;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(TF2BigRevolverTrailEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TF2BigRevolverTrailParticle";

   useEmitterColors = true;

   uiName = "";
};

datablock ProjectileData(TF2BigRevolverTrailProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = gunExplosion;
   particleEmitter     = TF2BigRevolverTrailEmitter;
   explodeOnDeath = false;
   
   directDamage        = 30;
   directDamageType    = $DamageType::TF2BigRevolver;
   directDamageType    = $DamageType::TF2BigRevolver;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   muzzleVelocity      = 150;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 90;
   bounceElasticity    = 0;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 1 0";
   
   uiName = "Ambassador Trail";
};

//Critical Trail
datablock ParticleData(TF2BigRevolverCritTrailParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/ring";
   spinSpeed		   = 0.0;
   spinRandomMin		= 0.0;
   spinRandomMax		= 0.0;
   colors[0]     = "0.5 0.65 1 0.5";
   colors[1]     = "0.5 0.65 1 0.1";
   colors[2]     = "0.5 0.65 1 0";

   sizes[0]      = 0.8;
   sizes[1]      = 0.3;
   sizes[2]      = 0.1;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(TF2BigRevolverCritTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TF2BigRevolverCritTrailParticle";

   useEmitterColors = true;

   uiName = "";
};

datablock ProjectileData(TF2BigRevolverCritTrailProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = gunExplosion;
   particleEmitter     = TF2BigRevolverCritTrailEmitter;
   explodeOnDeath = false;
   
   directDamage        = 30;
   directDamageType    = $DamageType::TF2BigRevolver;
   directDamageType    = $DamageType::TF2BigRevolver;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   muzzleVelocity      = 150;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 10;
   bounceElasticity    = 0;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0.5 0.65 1";
   
   uiName = "Ambassador Trail (Crit)";
};

//////////
// item //
//////////
datablock ItemData(TF2BigRevolverItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Ambassador.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "The Ambassador";
	iconName = "./icon_bigrevolver";

	 // Dynamic properties defined by the scripts
	image = TF2BigRevolverImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TF2BigRevolverImage)
{
   // Basic Item properties
   shapeFile = "./Ambassador.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 -0.05 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TF2BigRevolverItem;
   ammo = " ";
   projectile = TF2BigRevolverTrailProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   
   //Inaccuracy stays for this time even if you put it away
   minShotTime = 1600;
   
   //Raycasting Weapons settings
   //raycastWeaponRange = 1000;
   //raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   //				$TypeMasks::PlayerObjectType |	//AI/Players
   //				$TypeMasks::StaticObjectType |	//Static Shapes
   //				$TypeMasks::TerrainObjectType |	//Terrain
   //				$TypeMasks::VehicleObjectType;	//Vehicles
   //raycastWeaponPierceTargets = $TypeMasks::PlayerObjectType  |	//Targets the weapon can pierce through: AI/Players
   //				$TypeMasks::VehicleObjectType;	//Vehicles
   //raycastExplosionProjectile = gunprojectile;
   //raycastExplosionSound = ""; //sound played by exploding gunprojectile
   //raycastDirectDamage = 30;
   //raycastDirectDamageType = $DamageType::TF2BigRevolver;
   //raycastCritDirectDamageType = $DamageType::RevolverHeadshot;
   //raycastSpreadCount = 1;
   //raycastSpreadAmt = 0; //except for inaccuracy
   //raycastTracerProjectile = TF2BigRevolverTrailProjectile;
   //raycastCritTracerProjectile = TF2BigRevolverCritTrailProjectile;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]			= weaponSwitchSound;
					
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;
	stateSequence[1]		= "Ready";
	
	stateName[2]			= "Fire";
	stateTransitionOnTimeout[2]	= "Turn";
	stateTimeoutValue[2]		= 0.02;
	stateFire[2]			= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]		= "Ready";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.02;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= TF2BigRevolverShotSound;
	
	stateName[3]			= "Turn";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.8;
	stateEmitterNode[3]		= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateSequence[3]		= "Reload";
	stateTimeoutValue[3]            = 0.6;
	stateTransitionOnTimeout[3]     = "Smoke";
					
	stateName[4]			= "Smoke";
	stateWaitForTimeout[4]		= false;
	stateEmitter[4]			= gunSmokeEmitter;
	stateEmitterTime[4]		= 0.8;
	stateEmitterNode[4]		= "muzzleNode";
	stateTimeoutValue[4]            = 0.8;
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateTransitionOnTimeout[4]     = "Ready";
};

function TF2BigRevolverImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
	{
		%projectile = %this.projectile;
		%spread = 0.0035;
	}
        else
	{
		%projectile = TF2BigRevolverCritTrailProjectile;
                %spread = 0;
		serverplay3d(critFireSound,%obj.getHackPosition());
	}
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	
	%obj.lastFireTime = getSimTime();
        
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, activate);
        
	return %p;	
}

function TF2BigRevolverCritTrailProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = %this.directDamage;
   %damage = %directDamage;

   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
      if(isObject(%sobj.client))
         %sobj.client.play2d(bulletHitSound);
   }
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 3;
         %damageType = $DamageType::RevolverHeadshot;
         
         %col.spawnExplosion(critProjectile,%colscale);
         if(isObject(%col.client))
            %col.client.play2d(critRecieveSound);
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            if(isObject(%sobj.client))
               %sobj.client.play2d(critHitSound);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}